/*
 * Copyright (c) 1997  XMaZ Project.
 *
 *  isoternet Protocol Library / iPv4 module / iP datagram
 *
 *  $Id$
 */

#ifndef _IP_H_ 
#define _IP_H_

#include <ttypes.h>
#include <if.h>

/* ip */

typedef struct {
	BYTE ip_vhl;		/* Prootocol Versioin & Header Length */
	BYTE ip_tos;		/* Type of Service */
	WORD ip_len;		/* Total Length */
	WORD ip_id;			/* Identification for reassembly */
	WORD ip_flr;		/* flag & fragment offset */
	BYTE ip_ttl;		/* Time to Live */
	BYTE ip_proto;		/* Protocol */
	WORD ip_cksum;		/* Header Checksum */
	DWRD ip_src;		/* Source Address */
	DWRD ip_dst;		/* Destination Address */
} IP;

#define IPHLEN 20

extern WORD id;

/* icmp */

typedef struct {
	BYTE icmp_type;
	BYTE icmp_code;
	WORD icmp_cksum;
	WORD icmp_id;
	WORD icmp_seq;
	DWRD icmp_data;
} ICMP;

#define ICMPLEN 12

#if 0
/* network interface */

typedef struct {
    int  if_preflen;
	WORD if_mtu;
	DWRD if_addr;
    int  (* if_output)(void FAR *, WORD, DWRD);
} IF;
#endif

/*
#define IFS_SIZE 1

extern IF *ifs[IFS_SIZE];
*/


/* routing */

typedef struct {

					/* J  */

	IDWORD dest;			/* ĐzXg/lbgAhX 
					   0.0.0.0..ftHg[g */
	IDWORD destmask;		/* dest ̃lbg}XN
					   0.0.0.0..ftHg[g
					   255.255.255.255..zXg[g
					   ̑..lbg[N[g */
	IDWORD gateway;			/* Gateway (flag.gateway=ON̂) */
	IF *ifp;			/* lbg[NC^tF[X */
	struct {
		int valid:1;		/* ̃Gg͗L */
		int gateway:1;		/* indirect(gatewaygp)[g */
	} flag;


					/* JȂ */

	void /*routeentrytype*/ *next;	/* ̃Gg 0..ꂪŌ */
	uint refcount;			/* QƉ */

	/* refcount=0  flag.valid=0 ȂÃGg͖gpł */
} routeentrytype;


/* config option */

typedef struct {
	BYTE cksum_enabled;	/* M`FbNT 0..Ȃ 1..: 100 */
} ip_breg_type;


/* function declaration */

void ip_init(void);
int  ip_ifconfig(IF *p);
void ip_output(BYTE FAR *p, WORD len);
void ip_input(BYTE FAR *p, WORD len);
void ip_switch(BYTE FAR *p);
void ip_icmp(BYTE FAR *p);
void raw_enqueue(void FAR *p);
void FAR *raw_dequeue(void);

int  ip_rtadd(IDWORD dest, IDWORD destmask, IDWORD gateway, IF *ifp);
int  ip_rtremove(IDWORD dest, IDWORD destmask, IF *ifp);
const routeentrytype *ip_rtsearch(IDWORD dest);
const routeentrytype *ip_rtalloc(IDWORD dest);
void ip_rtfree(routeentrytype *r);
int  ip_rtget(int n, void FAR *buf, uint bufsize);


/*#define ip_thisaddr() (ifs[0]->if_addr)*/

#endif /* _IP_H_ */
