/*
 * Copyright (c) 1997  XMaZ Project.
 *
 *  isoternet Protocol Library / iPv4 Module / iCMP Echo routine
 *
 *  $Id$
 */

#include <dos.h>
#include <mem.h>

#include <ttypes.h>
#include <inet.h>
#include <log.h>
#include <tmem.h>
#include <if.h>
#include "ip.h"



static IP FAR *lasticmp=NULL;		/* ŌɎMICMPpPbg
					   IPwb_ւ̃|C^ 
					   (GR[v) */



void ip_icmp(BYTE FAR *p)
{
	IP FAR	*h;
	ICMP FAR *d;
	DWRD tmp;
	WORD my_cksum, icmp_cksum, len;

	h = (IP FAR *) p;
	d = (ICMP FAR *) (p + IPHLEN);

	/* checksum */
	icmp_cksum = d->icmp_cksum;
	d->icmp_cksum = 0;
	len = inet_word(h->ip_len) - ((h->ip_vhl & 0x0f) << 2);
	my_cksum = in_cksum((BYTE FAR *)d, len);
	if (icmp_cksum != my_cksum) {
#ifdef DEBUG
		log_printf("iCMP: Checksum Error."); 
#endif
		tmem_free(p);
		return;
	}

	switch (d->icmp_type) {
	case 8:  /* Echo request */
		tmp = h->ip_src;
		h->ip_src = h->ip_dst;
		h->ip_dst = tmp;
		d->icmp_type = 0; /* Echo reply */
		d->icmp_cksum = 0;
		d->icmp_cksum = in_cksum((BYTE FAR *) d, len);
#ifdef DEBUG
		log_printf("iCMP: Echo request received.");
#endif 
		ip_output(p, len);
		break;
	default: /* Echo reply */
		/*raw_enqueue(p);*/
		if (lasticmp) {
			tmem_free(lasticmp);
		}
		lasticmp=h;
#ifdef DEBUG
		log_printf("iCMP: Received, type = %d.", d->icmp_type);
#endif 
		break;
	}
	return;
}

				/* icmp_send/recv p[^ */
typedef struct {
	void FAR *src;		/* IPpPbg̑M(zXgs) 
				   M NULL 
				   MIPADDRւ́@|C^ */
	void FAR *dest;		/* IPpPbg̑M(zXgs) */
				/* dest́A
				   MIPADDR܂IPAhXւ́A
				   MIPADDRւ́@|C^ */
	BYTE ttl;		/* TTL(Œzbv) */
	BYTE dmy;

	BYTE itype;		/* ICMP^Cv */
	BYTE code;		/* ICMPR[h */
	WORD id;		/* ICMPbZ[Wʔԍ */
	WORD seq;		/* ICMPbZ[WV[PXԍ */
	void FAR *buf;		/* ICMPIvVf[^ւ̃|C^ */
	WORD len;		/* LIvVf[^̃TCY(oCg) */
				/* IvVf[^Ƃ́Ał́A
				   ICMPpPbg擪8oCgڈȍ~̃f[^
				   wB*/
} ICMPPRM;

#define ICMPHLEN 8		/* ICMPwb_TCYioCgj
				   ʔԍAV[PXԍ܂ */

#define fmcpy(S,D,l) movedata(FP_SEG(S), FP_OFF(S), FP_SEG(D), FP_OFF(D), (l))

#define EICMP_NODATA  14/*Mf[^Ȃ				*/
#define EICMP_NOHOST  18/*ڑ悪Ȃ				*/
#define EICMP_NOMEM   19/*s					*/

/*
@́Ficmpprm
@óFchar			0..
				EICMP_NOMEM..擾łȂ
				EICMP_NOHOST..ĐɃzXgw肳ꂽ

  APIdl
@́FES:DI=ICMPPRM\̂̃AhX
@óFI
		CF = 0
		AL = 0
	ُI
		CF = 1
		AL = G[R[h
*/
char icmp_send(ICMPPRM FAR *icmpprm)
{
	WORD pktlen;
	WORD icmplen;
	BYTE FAR *p;
	ICMP FAR *d;
	void FAR *optd;		/* IvṼf[^ */
	IDWORD dest;		/* Đ IPAhX */

	if (inet_toipv4addr(icmpprm->dest,&dest)) {
		/* ĐɃzXgw肳ꂽ */
		return EICMP_NOHOST;
	}

	icmplen = ICMPHLEN + icmpprm->len;
	pktlen = PREFLEN + IPHLEN + icmplen;

	p = tmem_alloc((pktlen + 15) / 16);
	if (!p) {
#ifdef DEBUG
		log_put("icmp_send: not enough memory");
#endif /* DEBUG */
		return EICMP_NOMEM;
	}

	p += PREFLEN;				/* IPwb_ */
	d = (ICMP FAR *)(p + IPHLEN);		/* ICMPwb_ */
	optd = (BYTE FAR *)d + ICMPHLEN;	/* IvVf[^*/

	/*((IP FAR *)p)->ip_src = ;*/
	((IP FAR *) p)->ip_proto = 1;
	((IP FAR *) p)->ip_dst = dest;
	((IP FAR *) p)->ip_ttl = icmpprm->ttl;
	d->icmp_type = icmpprm->itype;
	d->icmp_code = icmpprm->code;
	d->icmp_cksum = 0;
	d->icmp_id = inet_word(icmpprm->id);
	d->icmp_seq = inet_word(icmpprm->seq);

	if (icmpprm->buf != NULL && icmpprm->len != 0) 
		fmcpy(icmpprm->buf,optd,icmpprm->len);

	d->icmp_cksum = in_cksum((BYTE FAR *) d, icmplen);

	ip_output(p, icmplen);

	return 0;
}


/*
@́Ficmpprm
@óFchar			0..
				EICMP_NODATA..ICMPpPbg͓ĂȂ

  APIdl
@́FES:DI=ICMPPRM\̂̃AhX
		̍\̂ttl,itype,code,id,seq͖Lŗǂ
		src,dest,bufNULLw\B̂ƂꂼAMAhX
		MAhXAIvVf[^͎擾łȂB
@óFI
		CF = 0
		AL = 0
		ICMPPRM\̂ttl,itype,code,id,seq,lentB[h
		src,dest,buf ̎ẅ̒g
	ُI
		CF = 1
		AL = G[R[h

  ⑫FłŌɓICMPpPbg(GR[v)擾B
        擾ƁAL^͍폜B
*/
char icmp_recv(ICMPPRM FAR *icmpprm)
{
	IP FAR *h;
	ICMP FAR *d;
	void FAR *optd;			/* IvṼf[^ */
	uint len;

	if (!lasticmp) return EICMP_NODATA;

	h = (IP FAR *)lasticmp;			/* IPwb_ */
	d = (ICMP FAR *)((BYTE FAR *)h + IPHLEN);
						/* ICMPwb_ */
	optd = (BYTE FAR *)d + ICMPHLEN;	/* IvVf[^*/

	len = inet_word(h->ip_len) - ((h->ip_vhl & 0x0f) << 2) 
		- ICMPHLEN;			/* IvVf[^ */

	if (icmpprm->src) {
		inet_ipv4addrtoipaddr(h->ip_src,icmpprm->src);
	}
	if (icmpprm->dest) {
		inet_ipv4addrtoipaddr(h->ip_dst,icmpprm->dest);
	}
	icmpprm->ttl = h->ip_ttl;
	icmpprm->seq = inet_word(d->icmp_seq);
	icmpprm->id  = inet_word(d->icmp_id);
	icmpprm->itype = d->icmp_type;
	icmpprm->code  = d->icmp_code;
	if (icmpprm->buf) {
		if (icmpprm->len < len) len = icmpprm->len;
		fmcpy(optd, icmpprm->buf, len);
		icmpprm->len = len;
	}

	tmem_free(lasticmp);
	lasticmp=NULL;

	return 0;
}

/*
1997/  /  
2001/ 4/ 8 ping_send,ping_recv
2001/ 4/10 ping_send,ping_recvp~Bicmp_send,icmp_recv
2001/ 4/23 icmp_recv: MpPbg TTLlԂ
2001/ 4/24 icmp_send: ICMPPRM.buf/len 
*/
