/*
	[eBO
*/

#include <mem.h>	/* movedata */
#include <dos.h>	/* FP_* */

#include <ttypes.h>
#include <inet.h>
#include <if.h>
#include "ip.h"

#define ON  1
#define OFF 0

#define ROUTEENTRIESMAX 4		/* őGg */



 int ip_route_dmy=0;
static routeentrytype *top=NULL;
static routeentrytype entry[ROUTEENTRIESMAX]={0};


/*******************************
	R[h
*******************************/

static routeentrytype *emptyentry(void)
{
	routeentrytype *r;

	for (r=entry; r<entry+ROUTEENTRIESMAX; r++) {
		if (r->flag.valid==OFF && r->refcount==0) return r;
	}

	return NULL;
}


/*
}XN̔r
@⑫F 0.0.0.0 ŏA255.255.255.255 ő
*/
static cmpmask(IDWORD *a, IDWORD *b)
{
	DWORD ah,bh;

	ah=inet_dword(*a);
	bh=inet_dword(*b);
	return (ah==bh) ? 0 : (ah<bh) ? -1 : 1;
}



/*
[eBOGgǉ
@óFint				0.. -1..G[(GgǉłȂ
  ⑫Fgateway=0.0.0.0 ̂ƂAdirect[gB
  ToDoFdestmask }XNƂĐBs悪Ggɑ݂
  	邩
	gateway ړB\B
*/
int ip_rtadd(IDWORD dest, IDWORD destmask, IDWORD gateway, IF *ifp) 
{
	routeentrytype *r,*i0,*i;
	routeentrytype *r_next;		/* ǉGg next ɓl*/

	r=emptyentry();
	if (r==NULL) return -1;

	r->dest=dest & destmask;
	r->destmask=(r->dest == 0) ? 0 : destmask;
	r->gateway=gateway;
	r->flag.gateway=(gateway!=0) ? ON : OFF;
	r->ifp=ifp;

	r->flag.valid=ON;
	r->refcount=0;

	/* Ggǉ */

	r_next=NULL;
	for (i0=NULL,i=top; i!=NULL; i0=i,i=i->next) {
		if(cmpmask(&r->destmask,&i->destmask)>=0) {
			if (i0==NULL) r_next=top;
			else r_next=i;
			break;
		}
	}

	/* ̎_ŁA
		top==NULL ̂ƂA
			i0=NULL,r_next=NULL
		else r Ōɓ鎞(rmaskŒZ(ŏ))A
			i0=Ō̃Gg,r_next=NULL
		else r ŏɂ鎞(rmaskŒ)
			i0=NULL,r_next=top
		else
			i0= i0̎r悤ȃGgi0
			r_next=i0̎
	*/

	if (i0==NULL) {
		/* 擪ɓ */
		top=r;
	}
	else {
		/* i0 ̌ɓ */
		i0->next=r;
	}

	r->next=r_next;

	return 0;
}


/*
[eBOGg폜
*/
static int remove(routeentrytype *r)
{
	routeentrytype *i,*i0;

	for (i0=NULL,i=top; i!=NULL; i0=i,i=i->next) {
		if (i==r) {
			if (i0==NULL) top=r->next;
			else i0->next=r->next;
			return 0;
		}
	}

	return -1;
}



/*
[eBOGg폜
(refcount>0 ̏ꍇ flag.validOFFɂ݂̂ō폜Ȃ)
@óFint				0.. -1..YGgȂ
*/
int ip_rtremove(IDWORD dest, IDWORD destmask, IF *ifp)
{
	routeentrytype *i;

	dest &= destmask;
	for (i=top; i!=NULL; i=i->next) {
		if (i->dest==dest && i->destmask==destmask && i->ifp==ifp) {
			i->flag.valid=OFF;
			if (i->refcount==0) remove(i);
			return 0;
		}
	}

	return -1;
}


/*
[ǧ
*/
static routeentrytype *search(IDWORD dest)
{
	routeentrytype *i;

	for (i=top; i!=NULL; i=i->next) {
		if ( i->flag.valid && ((dest & i->destmask)==i->dest) ) {
			return i;
		}
	}

	return NULL;
}


/*
[ǧ
*/
routeentrytype const *ip_rtsearch(IDWORD dest)
{
	return search(dest);
}



/*
[g̎擾
*/
routeentrytype const *ip_rtalloc(IDWORD dest)
{
	routeentrytype *r;

	r=search(dest);
	if (r) {
		if (r->refcount<65535) {
			r->refcount++;
			return r;
		}
	}

	return NULL;
}

/*
[g̉
*/
void ip_rtfree(routeentrytype *r)
{
	if (r->refcount) r->refcount--;
	if (r->flag.valid==OFF && r->refcount==0) {
		remove(r);
	}
}


/*******************************
	API
*******************************/


typedef struct {
	IPADDR	dest;
	uchar destmask;
	IPADDR	gateway;
	WORD flag;
	uchar interface;
} routeentryinfotype;



/*
[eBOGg̎擾
@⑫F
*/
int ip_rtget(int n, void FAR *buf, uint bufsize)
{
	routeentryinfotype rei;
	routeentrytype *r;

	for (r=top; r!=NULL && n>0; r=r->next,n--);

	if (r) {
		inet_ipv4addrtoipaddr(r->dest,&rei.dest);
		rei.destmask=inet_ipv4masktobits(r->destmask);
		inet_ipv4addrtoipaddr(r->gateway,&rei.gateway);
		rei.flag=(WORD)*((BYTE *)&r->flag);
		rei.interface=r->ifp->if_id;

		movedata(FP_SEG(&rei),FP_OFF(&rei),
			FP_SEG(buf),FP_OFF(buf),
			(bufsize < sizeof(routeentryinfotype) ) 
				? bufsize : sizeof(routeentryinfotype) );
		return 0;
	}
	else return -1;
}

#if 0
/*
[eBOGg̎擾
@⑫F
*/
int ip_rtget(int n, void FAR *buf, uint bufsize)
{
	routeentrytype *r;

	for (r=top; r!=NULL && n>0; r=r->next,n--);

	if (r) {
		movedata(FP_SEG(r),FP_OFF(r),
			FP_SEG(buf),FP_OFF(buf),
			(bufsize < sizeof(routeentrytype) ) 
				? bufsize : sizeof(routeentrytype) );
		return 0;
	}
	else return -1;
}
#endif

/*
2000/ 9/21 
2000/ 9/22 
2001/ 1/28 ip_rtget: IPADDRgďԂ悤ɕύXB
*/
