/*
 * Copyright (c) 1997  XMaZ Project.
 *
 *  isoternet Protocol Library / iPv4 Module / protocol switch
 *
 *  $Id$
 */

#include <ttypes.h>
#include <inet.h>
#include <tmem.h>
#include <log.h>
#include <udp.h>
#include <if.h>
#include "ip.h"

void ip_switch(BYTE FAR *p)
{
	IP FAR *h;
	WORD hlen;

	h = (IP FAR *) p;
	switch (h->ip_proto) {
	case 1: 
		ip_icmp(p);
		break;
	case 6:
		tcp_receive(((BYTE FAR *)p)+IPHLEN,inet_word(h->ip_len)-IPHLEN
								   ,h->ip_src);
		break;
	case PROTO_UDP:
        p += IPHLEN - PSEUDOHLEN;
		udp_input(p, inet_word(h->ip_len) - IPHLEN);
		break;
	default:
#ifdef DEBUG
		log_printf("ip_switch: Received, protocol = %d\n", h->ip_proto);
#endif
		tmem_free(p);
	}
	return;
}
