/*
 *  Copyright (C) 1997,2000 XMaZ Project.
 *
 *  isoternet Protocol Library / uDP Module / input routine
 *
 */

/*#include <tdef.h>*/
#include <ip.h>
#include <tmem.h>
#include <dos.h>
#include <mem.h>
#include <if.h>
#include "udp.h"

IDWORD ifman_thisaddr(void);

#define TMP

#ifdef TMP
#define fmcpy(S,D,l) movedata(FP_SEG(S), FP_OFF(S), FP_SEG(D), FP_OFF(D), (l))
/*void dns_receive(BYTE far *udppacket);*/
void udpapi_input(UDP far *p);
#endif

/*
	p=zwb_擪
	msglen=UDPwb_+f[^̒
*/
int udp_input(void FAR *p, WORD msglen)
{
	UDP	FAR *m;


	WORD udp_cksum, my_cksum;
	int i;
	WORD hlen;

	m = (UDP FAR *) p; 

	/* message length */
	if (msglen < UDPHLEN) {

#ifdef DEBUG
		log_printf("udp_input: datagram is shorter than udphdr.");
#endif /* DEBUG */

		tmem_free(p);
		return 1;
	}
	if (msglen != inet_word(m->udp_msglen)) {

#ifdef DEBUG
		log_printf("udp_input: message length");
#endif /* DEBUG */

		tmem_free(p);
		return 1;
	}

	/* pseudo header */
	m->pseudo_len = m->udp_msglen;
	m->pseudo_zero = 0;

	/* checksum */
	if ((udp_cksum = m->udp_cksum) != 0) {
		log_put("udp_input: cksum available");
		m->udp_cksum = 0;
		if ((my_cksum = in_cksum(m, PSEUDOHLEN + msglen)) == 0) {
			my_cksum = 0xffff;
		}
		if (my_cksum != udp_cksum) {

#ifdef DEBUG
			log_printf("udp_input: cksum");
#endif /* DEBUG */

			tmem_free(p);
			return 1;
		}
	}
	
#ifdef TMP

	/* put your routine */
	/*dns_receive((BYTE FAR *)m+PSEUDOHLEN+UDPHLEN);*/
	udpapi_input(m);

#else /* TMP */

	/* find socket & copy */
	for (i = 0; i < SO_MAX; i++) {
		if (so_match(i, p)) {
			hlen = PSEUDOHLEN + UDPHLEN;
			so_enqueue(socks[i].rbuf, m + hlen, msglen - hlen);
		}
	}

	tmem_free(p);

#endif /* TMP */


	return 0;
}

#ifdef TMP
int udp_output(void FAR *d, WORD len, WORD my_port, DWRD his_addr, WORD his_port)
#else
int udp_output(SOCKET FAR *s, void FAR *d, WORD len)
#endif

{
	UDP	FAR *m;

	WORD pktlen;
	WORD msglen;
	BYTE FAR *p, FAR *data;

	int	not_bind = 0;
	msglen = UDPHLEN + len;

#ifdef TMP
	pktlen = PREFLEN + IPHLEN + msglen;
#else
	pktlen = s->netif->if_preflen + IPHLEN + msglen;
#endif

	p = tmem_alloc((pktlen + 15) / 16);
	if (!p) {
#ifdef DEBUG
		log_put("udp_output: not enough memory");
#endif /* DEBUG */
		return 1;
	}

#ifdef TMP
	p += PREFLEN;
#else
	p += s->netif->if_preflen;
#endif

	m = (UDP FAR *) (p + IPHLEN - PSEUDOHLEN); 
	data = (BYTE FAR *) m + PSEUDOHLEN + UDPHLEN;

	/* pseudo header */
	m->pseudo_zero = 0;
	m->ip_proto = PROTO_UDP;
	m->pseudo_len = inet_word(msglen);
#ifdef TMP
	m->ip_src = ifman_thisaddr();
	m->ip_dst = his_addr;

	/* message header */
	m->udp_sport = my_port;
	m->udp_dport = his_port;
#else
	m->ip_src = s->my_addr;
	m->ip_dst = s->his_addr;

	/* message header */
	m->udp_sport = s->my_port;
	m->udp_dport = s->his_port;
#endif
	m->udp_msglen = inet_word(msglen);
	
	/* payload */
	fmcpy(d, data, len);

	/* checksum */
	m->udp_cksum = 0;
	if ((m->udp_cksum = in_cksum(m, PSEUDOHLEN + msglen)) == 0) {
		m->udp_cksum = 0xffff;
	}
	
	/* ip header */
	((IP FAR *) p)->ip_ttl = 64;

	/* send */
	ip_output(p, msglen);

	return 0;
}

/*
    :
2000/ 9/ 1
2000/ 9/23 ϐifs폜ɂƂȂꎞIifman_thisaddrgpB
*/
