/*
	UDP API
	for i80x86

	$Header: udpapi.cv  1.1  98/11/05 19:23:44  Exp $
*/

#pragma inline

#include <dos.h>	/* __emit__,MK_FP */

#if !defined(NOLOG)
#include <string.h>	/* strcpy */
#endif

#include <ttypes.h>
#include <log.h>
#include <inet.h>
#include <ringbuf.h>
#include <if.h>
#include <ip.h>
#include <dnsclt.h>
#include "udp.h"
#include "udpapi.h"

IDWORD ifman_thisaddr(void);

/*******************************
@@@@@@}N
*******************************/


#define NULL 0
#define OFF 0
#define ON 1


/*------------------------------
  |[gԍ
------------------------------*/

#define PORT_RESERVED 1024	/* >port ł port͗\񂳂Ă */
#define PORT_USERRESERVED 5000 /* <port ł port͗\񂳂Ă */
				/* RESERVED <= port <= USERRESERVED 
				   蓖Ă|[gƂĎg */

#define PORTANY UDPPORT_ANY
#define ADDRANY IPADDR_ANY


/*------------------------------
  IPAhX
------------------------------*/

#define IPADDR_ANY 0



/*------------------------------
  ڑǗ
------------------------------*/

#define CONNECTIONSMAX 8	/* \ȃRlNV̍ő */

#define WORKINGMAX 255

#define workon(con)  ( ((con)->working<WORKINGMAX)? ((con)->working++,0) : -1 )
#define finish(con) ((con)->working--)
				/* workon  荞݂֎~ꂽԂŎs
				   ƁB
				*/


/*******************************
@@@@@@^
*******************************/

typedef enum {S_FREE,S_SEARCH,S_ESTAB,S_NOHOST} statetype;

static const char *statename[]={
	"FREE","SEARCH","ESTAB","NOHOST"
};


typedef struct {
	int strictpeer:1;	/* wɃChJ[hgpĂȂ */
} connectionflagtype;


typedef struct {
	BYTE handle;
	BYTE working;		/* ̃RlNVgĂƂ̐ */

	IWORD thisport;		/* ̃|[g */
	IDWORD thisip;		/* ̃AhX */
	IWORD peerport;		/* ̃|[g */
	IDWORD peerip;		/* ̃AhX */

	void (huge *callback)();

	ringbuftype r;		/* Mobt@ */

	statetype state;	/*  */
	connectionflagtype flag;/* tO */
	char nshandle;		/* Opnh -1.Ȃ */

} connectiontype;



/*******************************
@@@@@@ϐ
*******************************/

static connectiontype connection[CONNECTIONSMAX];


/*******************************
@@@@@vg^Cv
*******************************/

/* tmp_udp.c */
int udp_output(void far *d, WORD len, WORD my_port, DWRD his_addr, WORD his_port);


/*******************************
@@@@@@R[h
*******************************/

/*------------------------------
  
------------------------------*/

void udpapi_init(void)
{
	int i;

	for (i=0; i<CONNECTIONSMAX; i++) {
		connection[i].handle=i;
		connection[i].state=S_FREE;
	}
}


/*------------------------------
  荞ݐ
------------------------------*/
/*
̃t@CŌ̃RgQ
*/


/*
荞݋֎~
*/
static void _disable(void)
{
	__emit__(0xfa);	/* cli */
}

/*
荞݋
*/
static void _enable(void)
{
	__emit__(0xfb);	/* sti */
}


/*------------------------------
  
------------------------------*/

/*
ΉRlNVT
@ӁFsɃnhJȂƁBԂ ESTAB 瑼ɕύXȂƁB
*/
static connectiontype *searchconnection(const UDP far *p)
{
#define STRICT_PEERPORT 8
#define STRICT_PEERIP   4
#define STRICT_THISPORT 2
#define STRICT_THISIP   1

	int i;
	char lastmatch=-1;
	connectiontype *con,*lastcon=NULL;

	for (i=0, con=&connection[0]; i<CONNECTIONSMAX; i++,con++) {
		char match=0;

		if (con->state==S_ESTAB) {
			if (con->thisport!=PORTANY) {
				if (con->thisport != p->udp_dport) continue;
				match |= STRICT_THISPORT;
			}
			if (con->thisip!=ADDRANY) {
				if (con->thisip != p->ip_dst) continue;
				match |= STRICT_THISIP;
			}
			if (con->peerport!=PORTANY) {
				if (con->peerport != p->udp_sport) continue;
				match |= STRICT_PEERPORT;
			}
			if (con->peerip!=ADDRANY) {
				if (con->peerip != p->ip_src) continue;
				match |= STRICT_PEERIP;
			}

			if (match > lastmatch) {
				lastmatch=match;
				lastcon=con;
			}
		}
	}
	
	return lastcon;
}



/*
󂫃RlNVe[uT
@ӁFsɃnhǉȂƂۏ؂Ŏgp邱
*/
static char newhandle(void)
{
	int i;
	connectiontype *con;

	con=connection;
	for (i=0; i<CONNECTIONSMAX; i++,con++) {
		if (con->state==S_FREE) return i;
	}

	return -1;
}


/*
nh->connectiontype
  nhsȂƂ́ANULLԂB
@ӁFsɃnhJȂƂۏ؂Ŏgp邱
*/
static connectiontype *handle2connection(BYTE handle)
{
	connectiontype *con;

	con=&connection[handle];
	return (handle>=CONNECTIONSMAX || 
	        con->state==S_FREE ) ? NULL : con;
}

#if 0
/*
nhɑΉRlNV擾ÃRlNVuƒvɂ
@óFconnectiontype *	RlNV
	char err		0.G[Ȃ ̑.G[R[h
*/
static connectiontype *workonhandle(BYTE handle, uchar *err)
{
	connectiontype *con;

	*err=0;

	_disable();

	if ( (con=handle2connection(handle))==NULL ) *err=EUDP_BADHANDLE;
	else if ( workon(con) ) *err=EUDP_BUSY;

	_enable();

	return con;
}
#endif


/*
|[gԍnhɂĎgpH
@ӁFsɃnhǉȂƂۏ؂Ŏgp邱
*/
static int portisused(WORD port)
{
	int i;
	
	port=inet_word(port);
	for (i=0; i<CONNECTIONSMAX; i++) {
		if (connection[i].state != S_FREE && 
		    connection[i].thisport==port) return ON;
	}
	return OFF;
}


/*
ԕύX
*/
static void setstate(connectiontype *con, statetype state)
{
	con->state=state;
#if !defined(NOLOG)
	log_printf("UDP : J Handle %d -> %s",con->handle,statename[state]);
#endif
}

/*------------------------------
  M
------------------------------*/

/*
@́Fp=zwb_擪

@Mobt@Ƀf[^ǉ̂͂̊֐݂̂łB
@̊֐̎s
@@ēĂ悢B
@  udp_close ֎~邽߁Aworkon gp
@@LɂnhJ邱Ƃ͂ȂB
    Mobt@Nf[^oĂǂB
@@Oobt@쒆ɑ̃Oobt@삪荞܂Ȃ悤ɎŊǗ

  R[obNďoɃR[obNĂяoȂlɂB
*/
void udpapi_input(UDP far *p)
{
	connectiontype *con;
	uint packetlen;

	packetlen= inet_word(p->udp_msglen) + PSEUDOHLEN;      /* p ̃TCY */

#if !defined(NOLOG)
	{
		char sadr[16],dadr[16];

		strcpy(sadr,inet_ntoa(p->ip_src));
		strcpy(dadr,inet_ntoa(p->ip_dst));
		log_printf("UDP : M %s:%u->%s:%u",
		    sadr,inet_word(p->udp_sport),dadr,inet_word(p->udp_dport));
	}
#endif
	_disable();
	if ( (con=searchconnection(p)) == NULL ) {
		/* Ή connection Ȃ */
		_enable();
		log_put("UDP : MnhȂ");
	}
	else {
		workon(con);
#if !defined(NOLOG)
		log_printf("UDP : M Handle=%d",con->handle);
#endif
		if (packetlen <= ringbuf_left(&con->r)) {
			ringbuf_put(&con->r, (BYTE far *)p, packetlen);

			_enable();

			if ((long)con->callback) con->callback();
		}
		else {
			_enable();
			log_printf("UDP : Mobt@t Handle=%d",con->handle);
		}

		finish(con);
	}

	tmem_free(p);
	return;
}

/*------------------------------
  NS R[obN
------------------------------*/

static void far nscallback(BYTE nshandle, BYTE handle)
{
	connectiontype *con;
	IDWORD ip;
	char ret;

	if ( (con=handle2connection(handle)) == NULL ) {
		/* ُ */
		log_printf("UDP : nscallback: nhُ %d",handle);
	}
	else {
		ret=ns_getipaddr(nshandle,&ip);
		if (ret==ENS_NORESPONSE) return;

		if (ret==0) {
			con->peerip=ip;
			if (ip==ADDRANY) {
				/* wȂ */
				con->peerport=PORTANY; /*=0*/
			}
			else {
				/* w肠 */
				con->flag.strictpeer = ON;
			}
			setstate(con,S_ESTAB);
		}
		else {
			/* w肠肾zXgȂ */
			setstate(con,S_NOHOST);
		}
		con->nshandle=-1;
	}
	ns_end(nshandle);
}

/*------------------------------
  API
------------------------------*/
/*
  UDP API  DNSCLT.C  TEENIF ɒڌĂ΂邱Ƃɒ

@UDP API̎s
@@TEENIF Ăꎩg͑ UDP API Ăяo邱Ƃ͂Ȃ
@@Lɂ(udp_closeȊO̎s)nhJ邱ƂȂB
@@Oobt@ւ̊e(ringbuf_xxx)̓Ag~bNɍsȂ悤 API ǗB
*/

/*
nh擾
@⑫Fhost=NULL ܂ host=0.0.0.0 ܂ peerport=PORTANY ̏ꍇ
	uwȂnhv
	łȂ΁uwtnhv

	wȂ̏ꍇ peerip=0,peerport=0,strictpeer=OFF ƂB
	wt̏ꍇ strictpeer=ON ƂB

	thisport=PORTANY ̂Ƃ͓Kȃ|[g蓖ĂB

@oOF thisip = ADDRANY 
	{́AS_ESTAB ԂɂƂɁAMɎgC^tF[XIP
	AhX thisip ɗ^B
*/

char udp_open(const UDPPRM far *prm)
{
	connectiontype *con;
	WORD thisport;
	char handle;
	int i;

	/* p[^ */
	thisport=prm->thisport;
	if (thisport != PORTANY && portisused(thisport) ) {
		/* ̃|[g͎gp */
		return 0x80 | EUDP_BADPORT;
	}

	if (prm->rbuf==0 || prm->rbufsize==0 || prm->rbank!=0 || prm->sbuf!=0 || prm->sbank!=0 || prm->sbufsize!=0 ) {
		return 0x80 | EUDP_RANGE;
	}



	if ( (handle=newhandle())<0 ) {
		/* nhs */
		return 0x80 | EUDP_NORESOURCE;
	}
				/* nhǉ̂͂̊֐łA
				   ̊֐͍ēȂA荞݋֎~̕K
				   vȂ */

	con=&connection[handle];
	con->working=0;

	ringbuf_init(&con->r,prm->rbuf,prm->rbufsize);
	con->callback=prm->callback;

	if ( thisport==PORTANY ) thisport=PORT_RESERVED+handle;
	con->thisport=inet_word(thisport);
	con->thisip=ADDRANY;

	con->peerport=inet_word(prm->peerport);	/* Ƃ肠 */
	con->peerip=ADDRANY;			/* Ƃ肠 */
	con->flag.strictpeer = OFF;		/* Ƃ肠 */
/*		(prm->host != NULL && prm->peerport != PORTANY) ? ON : OFF;*/

	if (prm->host && (prm->peerport != ADDRANY)) {
		/* zXgw肳ĂāApeerport!=PORTANY ̏ꍇB
		   host="0.0.0.0"̉\͂B*/
#if 0
		con->nshandle=ns_queryipaddr(prm->host,nscallback,handle);
#else
		{
			uint tmp;
asm			mov	tmp,offset nscallback;
			con->nshandle=ns_queryipaddr(prm->host,(void (far *)())MK_FP(_CS,tmp),handle);
		}
#endif
		if (con->nshandle & 0x80) {
			/* G[ */
			log_put("UDP : udp_open: ns_queryipaddr G[");
			return 0x80 | EUDP_NORESOURCE;
		}
		setstate(con,S_SEARCH);
		nscallback(con->nshandle,handle);
	}
	else {
		/* wȂ */
		con->peerport=PORTANY; /*=0*/
		setstate(con,S_ESTAB);
	}

	return handle;
}


/*
nhJ
*/
char udp_close(BYTE handle)
{
	connectiontype *con;
	char err=0;

	_disable();		/* sɁA̋@\iAPIĂяoj
				   Ċ荞܂Ȃ悤ɂ */

	if ( (con=handle2connection(handle))==NULL ) {
		err= 0x80 | EUDP_BADHANDLE;
	}
	else if ( con->working > 0 ) {
		/* ꂩgĂ */
		err= 0x80 | EUDP_BUSY;
	}
	else {

		if (con->nshandle>=0) ns_end(con->nshandle);
		con->state=S_FREE;

	}

	_enable();

	return err;
}


/*

@óFchar			<0x80 
				>=0x80 G[
*/
char udp_state(BYTE handle)
{
	connectiontype *con;

	if ( (con=handle2connection(handle)) == NULL ) 
		return 0x80 | EUDP_BADHANDLE;

	switch(con->state) {
	case S_SEARCH: return UDP_SEARCH;
	case S_ESTAB:  return UDP_OPEN;
	default:       return UDP_CLOSED;
	}
}



/*
M(Đt)
  óFlong			16bit=0: MoCg
  				16bit=0xffff: G[
  					EUDP_BADHANDLE
					EUDP_BADSTATE
@oOFMf[^̏s
	toaddr ɂ̓zXg͎włȂBEUDP_BADSTATE ԂB
*/
long udp_sendto(BYTE handle, const BYTE far *buf, uint len, const void far *toaddr, WORD toport)
{
	connectiontype *con;
	IDWORD toipv4addr;

	if ( (con=handle2connection(handle))==NULL ) {
		return 0xffff0000L | EUDP_BADHANDLE;
	}
				/* s udp_close@͌Ă΂Ȃ߁A
				@荞݂֎~ȂĂm con 
				*/

	if ( con->state != S_ESTAB ) {
		return 0xffff0000L | EUDP_BADSTATE;
	}

	if ( inet_toipv4addr(toaddr,&toipv4addr)!=0 ) {
		/* zXgw肳ꂽ */
		/* ݂͑MłȂ */
		return 0xffff0000L | EUDP_BADSTATE;
	}

#if !defined(NOLOG)
	log_printf("UDP : M Handle=%d ->%s:%u %u byte",handle,inet_ntoa(toipv4addr),toport,len);
#endif
	udp_output(buf,len,con->thisport,toipv4addr,inet_word(toport));

	/* ς */
	return (DWORD)len;
}


#if 1

/*
M
  óFlong			16bit=0: MoCg
  				16bit=0xffff: G[
  					EUDP_BADHANDLE
					EUDP_BADSTATE
  					EUDP_NOPEER wȂnhł
@oOFMf[^̏s
*/
long udp_send(BYTE handle, const BYTE far *buf, uint len)
{
	connectiontype *con;
	IPADDR toaddr;

	if ( (con=handle2connection(handle))==NULL ) {
		return 0xffff0000L | EUDP_BADHANDLE;
	}
				/* s udp_close@͌Ă΂Ȃ߁A
				@荞݂֎~ȂĂm con 
				*/

	if ( !con->flag.strictpeer ) {
		return 0xffff0000L | EUDP_NOPEER;
	}

	inet_ipv4addrtoipaddr(con->peerip,&toaddr);

	return udp_sendto(handle, buf, len, &toaddr, inet_word(con->peerport));
}


#else
/*
M
  óFlong			16bit=0: MoCg
  				16bit=0xffff: G[
  					EUDP_BADHANDLE
					EUDP_BADSTATE
  					EUDP_NOPEER
@oOFMf[^̏s
*/
long udp_send(BYTE handle, const BYTE far *buf, uint len)
{
	connectiontype *con;

	if ( (con=handle2connection(handle))==NULL ) {
		return 0xffff0000L | EUDP_BADHANDLE;
	}
				/* s udp_close@͌Ă΂Ȃ߁A
				@荞݂֎~ȂĂm con 
				*/

	if ( con->state != S_ESTAB ) {
		return 0xffff0000L | EUDP_BADSTATE;
	}
	
	if ( !con->flag.strictpeer ) {
		return 0xffff0000L | EUDP_NOPEER;
	}

#if !defined(NOLOG)
	log_printf("UDP : M Handle=%d ->%s:%u %u byte",handle,inet_ntoa(con->peerip),inet_word(con->peerport),len);
#endif
	udp_output(buf,len,con->thisport,con->peerip,con->peerport);

	/* ς */
	return (DWORD)len;
}
#endif




/*
M(M҃AhXt)
  óFlong			16bit=0: Rs[oCg
  				16bit=0xffff: G[
  					EUDP_BADHANDLE
  					EUDP_NODATA
  					EUDP_BUFOVER

  ⑫F
	EUDP_BUFOVER̂ƂBUFlenoCgRs[Ă邪Aӂꂽ͎
	ĂB
	len=0  Mf[^>0 ̂ƂApPbgRs[Ɏ̂āA
	EUDP_BUFOVERԂB

	wtnhł́A肪M҂łpPbĝݎMB

	fromport,fromaddr  NULL w\

@̋@\̎s
@@̎sȊOŁAMobt@f[^o邱Ƃ͂Ȃ
@@̎s udp_recv Ăяo邱Ƃ͂ȂB
@@Mf[^ǉĂȂB
*/
long udp_recvfrom(BYTE handle, BYTE far *buf, uint len, 
				IPADDR far *fromaddr, WORD far *fromport)
{
	connectiontype *con;
	uint datalen,copylen;


	if ( (con=handle2connection(handle))==NULL ) {
		return 0xffff0000L | EUDP_BADHANDLE;
	}
				/* s udp_close@͌Ă΂Ȃ߁A
				@荞݂֎~ȂĂm con 
				*/
/*
	if ( con->state != S_ESTAB ) {
		return 0xffff0000L | EUDP_BADSTATE;
	}
	̏ꍇ͎Mf[^Ȃ͂Ȃ̂ŌKvȂ
*/
/*
	if ( !con->flag.strictpeer ) {
		return 0xffff0000L | EUDP_NOPEER;
	}
*/
	/* Mf[^邩H */
	if ( ringbuf_used(&con->r) < sizeof(UDP) ) {
		return 0xffff0000L | EUDP_NODATA;
	}

	/* UDP wb_o */
	{
		UDP udp;

		ringbuf_sense(&con->r,(BYTE far *)&udp,sizeof(UDP));
		copylen = datalen = inet_word(udp.udp_msglen) - UDPHLEN;
		if (fromport) *fromport = inet_word(udp.udp_sport);
		if (fromaddr) inet_ipv4addrtoipaddr(udp.ip_src,fromaddr);
	}

	if (copylen > len) copylen = len;
	len = datalen-copylen;			/* Rs[łȂoCg*/

	/* ȉ͎sȂsł͂ */
	/* ē邱ƂȂ̂ŁA荞݋֎~ɂȂĂȉ̑̈
	   ͕ۂĂ 
	*/
	ringbuf_delete(&con->r, sizeof(UDP));
	ringbuf_get(&con->r, buf, copylen);
	ringbuf_delete(&con->r, len);

	return (len>0) ? (0xffff0000L | EUDP_BUFOVER) : copylen;
}


#if 1

/*
M
  óFlong			16bit=0: Rs[oCg
  				16bit=0xffff: G[
  					EUDP_BADHANDLE
  					EUDP_NODATA
  					EUDP_BUFOVER

  ⑫F
	EUDP_BUFOVER̂ƂBUFlenoCgRs[Ă邪Aӂꂽ͎
	ĂB
	len=0  Mf[^>0 ̂ƂApPbgRs[Ɏ̂āA
	EUDP_BUFOVERԂB

	wtnhł́A肪M҂łpPbĝݎMB

@̋@\̎s
@@̎sȊOŁAMobt@f[^o邱Ƃ͂Ȃ
@@̎s udp_recv Ăяo邱Ƃ͂ȂB
@@Mf[^ǉĂȂB
*/
long udp_recv(BYTE handle, BYTE far *buf, uint len)
{
	return udp_recvfrom(handle,buf,len,NULL,NULL);
}

#else

/*
M
  ⑫Flen=0̂ƂApPbgRs[Ɏ̂Ă
@̋@\̎s
@@̎sȊOŁAMobt@f[^o邱Ƃ͂Ȃ
@@̎s udp_recv Ăяo邱Ƃ͂ȂB
@@Mf[^ǉĂȂB
*/
long udp_recv(BYTE handle, BYTE far *buf, uint len)
{
	connectiontype *con;
	uint datalen,copylen;


	if ( (con=handle2connection(handle))==NULL ) {
		return 0xffff0000L | EUDP_BADHANDLE;
	}
				/* s udp_close@͌Ă΂Ȃ߁A
				@荞݂֎~ȂĂm con 
				*/
/*
	if ( con->state != S_ESTAB ) {
		return 0xffff0000L | EUDP_BADSTATE;
	}
	̏ꍇ͎Mf[^Ȃ͂Ȃ̂ŌKvȂ
*/
	if ( !con->flag.strictpeer ) {
		return 0xffff0000L | EUDP_NOPEER;
	}

	/* Mf[^邩H */
	if ( ringbuf_used(&con->r) < sizeof(UDP) ) {
		return 0xffff0000L | EUDP_NODATA;
	}

	copylen = datalen = 
		inet_word(((UDP far *)(con->r.bufh))->udp_msglen) - UDPHLEN;
	if (copylen > len) copylen = len;
	len = datalen-copylen;			/* Rs[łȂoCg*/

	/* ȉ͎sȂsł͂ */
	/* ē邱ƂȂ̂ŁA荞݋֎~ɂȂĂȉ̑̈
	   ͕ۂĂ 
	*/
	ringbuf_delete(&con->r, sizeof(UDP));
	ringbuf_get(&con->r, buf, copylen);
	ringbuf_delete(&con->r, len);

	return (len>0) ? (0xffff0000L | EUDP_BUFOVER) : copylen;
}
#endif


/*
̃AhXƃ|[gԍ𓾂
@óFchar			0      
				>0     G[
					EUDP_BADHANDLE
@⑫FS_ESTAB ȊO̎ IPAhXƂ ipaddr_any Ԃ
	wȂł IP AhXƂ ipaddr_any Ԃ
@oOFcon->thisip QƂȂ
*/
char udp_getmyaddr(BYTE handle, IPADDR far *addr, WORD far *port)
{
	connectiontype *con;

	if ( (con=handle2connection(handle))==NULL ) {
		return EUDP_BADHANDLE;
	}


	*port=inet_word(con->thisport);
	if (con->state == S_ESTAB && con->flag.strictpeer) {
		inet_ipv4addrtoipaddr(ifman_thisaddr(),addr);
	}
	else {
#if 0
		*addr=ipaddr_any;
#else
		fmcopy(&ipaddr_any,addr,sizeof(IPADDR));
#endif
	}

	return 0;
}


/*
̃AhXƃ|[gԍ𓾂
@óFchar			0      
				>0     G[
					EUDP_BADHANDLE
@⑫FwȂnhł ipaddr_any UDPPORT_ANY ԂB
	wtnhł
	S_ESTAB ȊO̎ IPAhXƂ ipaddr_any Ԃ
@oOFcon->thisip QƂȂ
*/
char udp_getpeeraddr(BYTE handle, IPADDR far *addr, WORD far *port)
{
	connectiontype *con;

	if ( (con=handle2connection(handle))==NULL ) {
		return EUDP_BADHANDLE;
	}

	*port=inet_word(con->peerport);
	inet_ipv4addrtoipaddr(con->peerip,addr);

	return 0;
}


/*******************************
@@@@@@
*******************************/


/*
{́u荞݋֎~vɂ
@u荞݋֎~vɂ UDP-API w̃vOĂяo邱ƂhB
@Ȃ킿A
@@Eqr荞݁A^C}[荞݂֎~A
	udpapi_input , dns ̃R[obNĂяoȂ悤ɂB
@@EAPI ̌Ăяo֎~AĂяoꂽꍇ BUSY ԂB

@u荞݋֎~vsȂƂɂāAVɈȉ邱Ƃ͂ȂB
     EtHAOEhin[hEFA荞݂ɂȂsjɂē삵ĂvO API ĂяoƂ BUSY ԂBiudp_close ܂ށj

  iR[obN API ĂяoƂɂ BUSY ԂȂ悤ɂBj

*/

/*
1998/11/ 2 
1998/11/ 3 
2000/ 1/16 udp_recvfromBudp_recv  udp_recvfrom gď
2000/ 1/18 udp_sendtoBudp_send  udp_sendto gď
2000/ 1/20 udp_open EUDP_RANGE ԂB
2000/ 1/21 udp_getmyaddr, udp_getpeeraddrBudp_recvfrom C
2001/ 4/ 7 udp_getmyaddrԂIPAhX̑3,4oCg255ɂȂ̂CB
	   (ifman_thisaddr̃vg^Cv錾ǉ邱ƂɂC)
*/
